local BonkCollide = function(mo,mobj)
	if not (mo and mo.valid) then return end
	if not (mobj and mobj.valid) then return end
	if ((mobj.z > mo.z+mo.height) or (mobj.z+mobj.height < mo.z)) then return end
	if (mobj.type != mo) then return end
	
	local prevmo = {x = mo.x-mo.momx, y = mo.y-mo.momy, z = mo.z-mo.momz, speed = FixedHypot(FixedHypot(mo.momx,mo.momy),mo.momz)}
	local prevmobj = {x = mobj.x-mobj.momx, y = mobj.y-mobj.momy, z = mobj.z-mobj.momz, speed = FixedHypot(FixedHypot(mobj.momx,mobj.momy),mobj.momz)}
	local speed = abs(prevmo.speed+prevmobj.speed)/2
	
	mo.state = S_PLAY_PAIN
	mobj.state = S_PLAY_PAIN
	
	local dxy = R_PointToDist2(prevmo.x,prevmo.y,prevmobj.x,prevmobj.y)
	local axy = R_PointToAngle2(prevmo.x,prevmo.y,prevmobj.x,prevmobj.y)
	
	local dz = R_PointToDist2(prevmo.z+(mo.height/2),0,prevmobj.z+(mobj.height/2),0)
	local az = R_PointToAngle2(0,0,dxy,dz)
	
	mo.momx = P_ReturnThrustX(mo,axy,-FixedMul(cos(az),speed))
	mo.momy = P_ReturnThrustY(mo,axy,-FixedMul(cos(az),speed))
	mo.momz = -FixedMul(sin(az),speed)
	
	mobj.momx = P_ReturnThrustX(mobj,axy,FixedMul(cos(az),speed))
	mobj.momy = P_ReturnThrustY(mobj,axy,FixedMul(cos(az),speed))
	mobj.momz = FixedMul(sin(az),speed)
	
	if mo.player and mo.player.valid
		mo.player.drawangle = axy
	end
	if mobj.player and mobj.player.valid
		mobj.player.drawangle = axy+ANGLE_180
	end
	
	local sound = P_SpawnMobj(
		prevmo.x+P_ReturnThrustX(nil,axy,dxy),
		prevmo.y+P_ReturnThrustY(nil,axy,dxy),
		prevmo.z+dz, MT_THOK)
	sound.state = S_INVISIBLE
	sound.fuse = TICRATE
	S_StartSound(sound,sfx_s3k5d)
end

//addHook("MobjCollide",BonkCollide,MT_PLAYER)
addHook("MobjMoveCollide",BonkCollide,MT_PLAYER)